
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef gyro_TCLSERV_CLIENT_ERROR_H
#define gyro_TCLSERV_CLIENT_ERROR_H

#include <server/gyroError.h>

/* -- MODULES ERRORS -------------------------------------------------- */

enum gyro_error {
	E_gyro_OK					  			= 0,

	/* module errors */
	E_gyro_CANNOT_WRITE_FILE              = S_gyro_CANNOT_WRITE_FILE,
	E_gyro_CANNOT_OPEN_FILE               = S_gyro_CANNOT_OPEN_FILE,
	E_gyro_FAILED                         = S_gyro_FAILED,
	E_gyro_NOT_CONNECTED                  = S_gyro_NOT_CONNECTED,
	E_gyro_CANNOT_DISCONNECT              = S_gyro_CANNOT_DISCONNECT,
	E_gyro_DECODE_FAILED                  = S_gyro_DECODE_FAILED,
	E_gyro_READ_FAILED                    = S_gyro_READ_FAILED,
	E_gyro_CANNOT_CONNECT                 = S_gyro_CANNOT_CONNECT,
	E_gyro_ALREADY_CONNECTED              = S_gyro_ALREADY_CONNECTED,


	/* std errors */
	E_gyro_ACTIVITY_INTERRUPTED           = S_gyro_stdGenoM_ACTIVITY_INTERRUPTED,
	E_gyro_TOO_MANY_ACTIVITIES            = S_gyro_stdGenoM_TOO_MANY_ACTIVITIES,
	E_gyro_ACTIVITY_FAILED                = S_gyro_stdGenoM_ACTIVITY_FAILED,
	E_gyro_WAIT_ABORT_ZOMBIE_ACTIVITY     = S_gyro_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY,
	E_gyro_UNKNOWN_ACTIVITY               = S_gyro_stdGenoM_UNKNOWN_ACTIVITY,
	E_gyro_FORBIDDEN_ACTIVITY_TRANSITION  = S_gyro_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION,
	E_gyro_SYSTEM_ERROR                   = S_gyro_stdGenoM_SYSTEM_ERROR,
	E_gyro_ACTIVITY_ALREADY_ENDED         = S_gyro_stdGenoM_ACTIVITY_ALREADY_ENDED,
	E_gyro_WAIT_INIT_RQST                 = S_gyro_stdGenoM_WAIT_INIT_RQST,
	E_gyro_CONTROL_CODEL_ERROR            = S_gyro_stdGenoM_CONTROL_CODEL_ERROR,
	E_gyro_EXEC_TASK_SUSPENDED            = S_gyro_stdGenoM_EXEC_TASK_SUSPENDED,
	E_gyro_BAD_BLOCK_TYPE                 = S_gyro_stdGenoM_BAD_BLOCK_TYPE,
	E_gyro_BAD_POSTER_TYPE                = S_gyro_stdGenoM_BAD_POSTER_TYPE,

};

typedef enum gyro_error gyro_error_t;

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Take an error string in parameter, and try to get the error index associated
 * to this string
 * Returns -1 in failure case (and err is not set)
 * Returns 0 in success case (and err has a sensitive value)
 */
int gyro_decode_error(const char* str, int *err);

/*
 * Take an integer representing an error, and try to get its textual
 * representation, in the gyro context.
 *
 * Returns NULL in case of failure
 */
const char* gyro_error_str(int err);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
